Easy Code® Visual Assembler v2
32-bit/64-bit (Windows XP and later)
Copyright © 2004-2021, Ramon Sala (Contributor: Héctor A. Medina).	All rights reserved.


WHAT'S NEW?
===========

 Easy Code Author: Ramon Sala
   Contact E-mail: assembly@easycode.cat
	Revision Date: October 16, 2021
  Current Version: 2
   Major Revision: 02
   Minor Revision: 0036


- Note
------
Please read and follow the directions within the AsmC.txt, Fasm.txt, Masm.txt, SolAsm.txt and UAsm.txt files located in the 'EasyCode' folder. Also, see the 'IMPORTANT REMARKS' section in the Easy Code help file.


- Bug Fixes
-----------
1. Windows API constants were not always converted to their correct syntax when the "Convert to API case" option was enabled.

2. The *.cfg files were not well created when they did not exist, that is, if the *.cfg files already existed then everything worked fine. Otherwise, if the *.cfg files did not exist because they had been deleted, or Easy Code v2 had been downloaded for the first time, then they were defectively created. I am really sorry for this serious bug!


- Added Features
----------------
None


- Deprecated Features
---------------------
None



<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><
-----------------------------------------------------------------------------
			 ~		EASY CODE v2 REVISIONS - RUNNING HISTORY	  ~
-----------------------------------------------------------------------------
<><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><


=====================================
> Version 2.02.0.0035 - 28-SEP-2021 <
=====================================

- Bug Fixes
----------------------
1. Fixed an error in the 'ECIncSol.inc' file affecting the SolAsm visual projects.

2. Fixed an error in the 'wininet.inc' file affecting the 32-bit Fasm visual projects.


- Added Features
----------------------
1. A new method, 'FloatToString', converts a double-precision value (REAL8 or QWORD) to a text string. Please see the 'FloatToString' method in the Easy Code help file.

2. A new method, 'StringToFloat', converts a text string to a double-precision value (REAL8 or QWORD). Please see the 'StringToFloat' method in the Easy Code help file.

3. Two new examples for JWASM, BinToAsci32 and BinToAsci64, programmed by Pavlu Zdenek.


- Deprecated Features
----------------------
None


=====================================
> Version 2.02.0.0034 - 20-AUG-2021 <
=====================================

- Bug Fixes
----------------------
No bug detected.


- Added Features
----------------------
1. The Easy Code view has been improved by increasing the font size by one point.

2. A new control, 'PicWindow', allows you to have little windows inside the main window. Please see the "The PicWindow control" topic in the Easy Code help file.

3. Now the 'Find Unused Resources' menu option also searches for unused local variables inside of procedures.

4. New "PicWindow" example projects for JWASM, FASM and GOASM (both, 32-bit and 64-bit) in the "\EasyCode\Examples" folder. The JWASM sources are the same for 32-bit ASMC, MASM, POASM and UASM, and a little different for 64-bit MASM and POASM.


- Deprecated Features
----------------------
None


=====================================
> Version 2.02.0.0033 - 22-JUN-2021 <
=====================================

- Bug Fixes
----------------------
1. Fixed an error ("Missing right parentheses") in the 'kernel32.inc' file (only ASMC detects that error).


- Added Features
----------------------
1. A new option in the "Edit-->Insert-->Color Number" menu allows you to choose a color and insert its hexadecimal number. If the color is a system color, it is converted to its real color.


- Deprecated Features
----------------------
None


=====================================
> Version 2.02.0.0032 - 04-MAY-2021 <
=====================================

- Bug Fixes
----------------------
1. The context help did not show the right type for a local variable when it was a buffer. For instance, szChar[24]:CHAR.


- Added Features
----------------------
1. Added the new 'Kalkulacka64s' example project for 64-bit JWASM (programmed by Pavlu Zdenek).


- Deprecated Features
----------------------
None


=====================================
> Version 2.02.0.0031 - 28-MAR-2021 <
=====================================

- Bug Fixes
----------------------
1. The "OutputString" method did not work for a 32-bit instance of Easy Code when a 64-bit instance was open at the same time (even with no project loaded).


- Added Features
----------------------
1. Added the new 'Kalkulacka3En' example project for 32-bit JWASM (programmed by Pavlu Zdenek).

2. Easy Code now recognizes and colorizes the new UASM "FrameOfs" operator.


- Deprecated Features
----------------------
None


=====================================
> Version 2.02.0.0030 - 18-FEB-2021 <
=====================================

- Bug Fixes
----------------------
1. Fixed an error in the code internally generated by Easy Code when creating a new POASM 64-bit visual project.


- Added Features
----------------------
1. New 'shlguid.inc' and 'shlobj.inc' files for ASMC, JWASM, MASM, POASM and UASM 64-bit projects.


- Deprecated Features
----------------------
None


=====================================
> Version 2.02.0.0029 - 30-DEC-2020 <
=====================================

- Bug Fixes
----------------------
1. The 'SetValue' procedure, which assigns the 'Value' property, did not work for 'Check' and 'Radio' objects.


- Added Features
----------------------
1. New 'crypt32.inc' file for SOLASM visual and classic projects.


- Deprecated Features
----------------------
None


=====================================
> Version 2.02.0.0028 - 12-NOV-2020 <
=====================================

- Bug Fixes
----------------------
1. Fixed a bug in the "wininet.inc" files for FASM visual and classic projects.


- Added Features
----------------------
1. Added a new method, "IsUserAdministrator", which determines whether the current user is an administrator or not. For more information, please see the "IsUserAdministrator" method in the Easy Code help file.

2. New 'wininet.inc' files for SOLASM visual and classic projects.

3. Supports the changes of the new GoAsm version 0.62 BetaO.


- Deprecated Features
----------------------
None


=====================================
> Version 2.02.0.0027 - 22-OCT-2020 <
=====================================

- Bug Fixes
----------------------
1. When a new project was created, it was not added to the project history.


- Added Features
----------------------
1. Added a new method, "MakeFullPath", which makes a full path by concatenating two text strings. For more information, please see the "MakeFullPath" method in the Easy Code help file.

2. Added a new tool, a file finder, available from the "Tools" menu.


- Deprecated Features
----------------------
None


=====================================
> Version 2.02.0.0026 - 24-SEP-2020 <
=====================================

- Bug Fixes
----------------------
1. Fixed a bug in the 'FindString' method which could return a wrong value.

2. The open projects history of the "File" menu did not work fine.

3. After building a project Easy Code did not show the right size of the built file.


- Added Features
----------------------
1. Added two more items to the open projects history of the "File" menu.

2. Added the new "AddCharToString" method which adds a character at the end of a text string. For more information, please see the "AddCharToString" method in the Easy Code help file.


- Deprecated Features
----------------------
None


=====================================
> Version 2.02.0.0025 - 08-SEP-2020 <
=====================================

- Bug Fixes
----------------------
No bug detected.


- Added Features
----------------------
1. Added the new "FileExists" method which checks wheather a file exists or not. For more information, please see the "FileExists" method in the Easy Code help file.

2. Added a nice and practical 64-bit example project ('ECWlan') for ASMC, FASM, GOASM, JWASM, MASM, POASM and UASM, which shows all available Wi-Fi networks (it needs Windows Vista or later). For POASM projects, please use the latest version of "poasm.exe" (v10.0.0.0).


- Deprecated Features
----------------------
None


- Necessary modifications
-------------------------
1. In order to work properly with FASM projects, please open your "Fasm.cfg" and "Fasm64.cfg" files and replace the whole line "Group8" with the following one:

Group8=CARRY?,OVERFLOW?,PARITY?,SIGN?,ZERO?


=====================================
> Version 2.02.0.0024 - 10-AUG-2020 <
=====================================

- Bug Fixes
----------------------
No bug detected.


- Added Features
----------------------
1. New 'd2d1' and 'DWrite' include files for 64-bit FASM and GOASM projects (the same files for ASMC, JWASM, MASM, POASM and UASM, and the corresponding libraries were already included in the previous version of Easy Code).

2. New 'ECPendulum' 64-bit example for ASMC, FASM, GOASM, JWASM, MASM, POASM and UASM, using the 'd2d1' and 'DWrite' files.


- Deprecated Features
----------------------
None


=====================================
> Version 2.02.0.0023 - 06-JUL-2020 <
=====================================

- Bug Fixes
----------------------
None


- Added Features
----------------------
1. New option to open the Registry Editor from the 'Tools' menu.

2. New 'd2d1.inc', 'DWrite.inc', 'd2d1.lib' and 'DWrite.lib' files for ASMC, JWASM, MASM, POASM and UASM 64-bit projects.


- Deprecated Features
----------------------
None


=====================================
> Version 2.02.0.0022 - 22-MAY-2020 <
=====================================

- Bug Fixes
----------------------
1. Visual projects fired errors when they were linked with the Easy Code Dynamic Library (option "Easy Code Library" of the "Project Properties").

2. Fixed a bug in the code generated by Easy Code for visual projects which made the GoAsm 'MDI' example (both, 32-bit and 64-bit) to fire an error.


- Added Features
----------------------
None


- Deprecated Features
----------------------
None


=====================================
> Version 2.02.0.0021 - 23-APR-2020 <
=====================================

- Bug Fixes
----------------------
1. Fixed a bug in the 'user32.inc' file ('\EasyCode\Include\SolAsm\Visual') which affected the SolAsm visual projects.


- Added Features
----------------------
1. Added the new "SetCueBanner" method that adds a cue banner to 'Edit' and 'Combo' controls. Please see the "SetCueBanner" method in the Easy Code help file.

2. New 'wintrust.inc' and 'wintrust.lib' files for ASMC, FASM, JWASM, MASM, POASM, SOLASM and UASM projects.

3. Improves the view of Easy Code when text size is greater than 100% (high DPI) but not yet completed.


- Deprecated Features
----------------------
None


=====================================
> Version 2.02.0.0020 - 04-APR-2020 <
=====================================

- Bug Fixes
----------------------
1. SolAsm visual projects including the "shell32.inc" file, failed due to an error in the referred file ("..\EasyCode\Include\SolAsm\Visual\shell32.inc").

2. Fixes a bug in the code editor that could make Easy Code to crash.


- Added Features
----------------------
1. The 'GetPlatform' method recognizes more Windows platforms.

2. The 'WebBrowser' example is also included for GoAsm and SolAsm.


- Deprecated Features
----------------------
None


=====================================
> Version 2.02.0.0019 - 09-MAR-2020 <
=====================================

- Bug Fixes
----------------------
1. A redefined structure in some files in the "\EasyCode\Include\Masm\x64" folder caused 64-bit driver projects of the ASMC, JWASM, MASM, POASM and UASM assemblers to fail.

2. A bug in Easy Code caused some "Dll" projects not to be built.

3. A bug in Easy Code caused ASMC "Lib" projects not to be built.


- Added Features
----------------------
None


- Deprecated Features
----------------------
None


=====================================
> Version 2.02.0.0018 - 24-FEB-2020 <
=====================================

- Bug Fixes
----------------------
1. An error in the "\EasyCode\Include\Fasm\Visual\kernel32.inc" file for FASM visual projects made some example projects to fire erros and not to build.


- Added Features
----------------------
1. New 'ddraw.inc', 'dinput.inc', 'ntdll.inc', 'ddraw.lib', 'dinput.lib' and 'ntdll.lib' files for ASMC, FASM, JWASM, MASM, POASM and UASM 64-bit projects.


- Deprecated Features
----------------------
None


=====================================
> Version 2.02.0.0017 - 08-FEB-2020 <
=====================================

- Bug Fixes
----------------------
1. A wrong value in the 'vt' member of the VARIANT structure (included in the "types.inc" file) meant that MASM64 projects could not be compiled with some versions of the "ml64.exe" compiler.


- Added Features
----------------------
1. A new 64-bit example project ('WebBrowser') for ASMC, FASM, JWASM, MASM, POASM and UASM shows how COM interfaces work (programmed by Héctor A. Medina).


- Deprecated Features
----------------------
None


=====================================
> Version 2.02.0.0016 - 18-JAN-2020 <
=====================================

- Bug Fixes
----------------------
1. Closing a long comment in GoAsm projects ('*/') added a second unnecessary slash.


- Added Features
----------------------
1. New 'UIAutomation.inc', 'UIAutomationClient.inc', 'UIAutomationCore.inc', 'UIAutomationCoreApi.inc' and 'UIAutomationCore.lib' files for ASMC, JWASM, MASM and UASM 64-bit projects.


- Deprecated Features
----------------------
None


=====================================
> Version 2.02.0.0015 - 20-DEC-2019 <
=====================================

- Bug Fixes
----------------------
No bug detected.


- Added Features
----------------------
1. New option to run the Task Manager from the 'Tools' menu.

2. New property 'Font' for 'SysLink' controls.

3. New snippets for a 'DoEvents' procedure for classic projects (32-bit/64-bit) similar to the 'DoEvents' Visual Basic function (visual projects already have their own 'DoEvents' method).

4. New 'SysLink' example for all assemblers (showing how the 'SysLink' control works).


- Deprecated Features
----------------------
None


=====================================
> Version 2.02.0.0014 - 08-NOV-2019 <
=====================================

- Bug Fixes
----------------------
1. Some 64-bit config files (.cfg) were not created correctly from their *.ori template file. This bug had no effect if the related .cfg file already existed.


- Added Features
----------------------
None


- Deprecated Features
----------------------
None


=====================================
> Version 2.02.0.0013 - 28-OCT-2019 <
=====================================

- Bug Fixes
----------------------
No bug detected.


- Added Features
----------------------
1. A new menu, "Edit-->Insert-->Date and Time (commented) Ctrl+D" makes the local date and time to be inserted as a comment.

2. A new 'Update' button in the Configurations window ('Tools-->Settings' menu, 'Configurations' tab) allows you to update a ".cfg" file from its corresponding ".ori" file when there are new keywords for any of the ten colour groups. For more information, please see the 'Configuring Easy Code' topic, 'Configurations' tab, in the Easy Code help file.


- Deprecated Features
----------------------
None


=====================================
> Version 2.02.0.0012 - 02-OCT-2019 <
=====================================

- Bug Fixes
----------------------
1. Fixes some errors in the SolAsm include files.

2. The 'OutputString' method did not work when the application calling the method was a 32-bit application and it was launched from a 64-bit Easy Code instance. The same happened with a 64-bit application if launched from a 32-bit Easy Code instance.


- Added Features
----------------------
1. New Czech language file (translated by Pavlu Zdenek - zpavlu@zpavlu.cz).

2. New Easy Code help file in Czech language (translated by Pavlu Zdenek - zpavlu@zpavlu.cz). Please download it at "http://easycode.cat/English/Download/ECv2CzechHelp.zip".

3. New 'netapi32.inc' and 'wlanapi.inc' files for SOLASM projects.


- Deprecated Features
----------------------
None


=====================================
> Version 2.02.0.0011 - 10-AUG-2019 <
=====================================

- Bug Fixes
----------------------
1. The Resource Editor accepted duplicated ID's.

2. Scrolling text up with the mouse did not work properly for the 64-bit version of Easy Code.


- Added Features
----------------------
1. New 'gdiplus.inc' and 'gdiplus.lib' files for ASMC, FASM, JWASM, MASM, SOLASM and UASM 64-bit projects.


- Deprecated Features
----------------------
None


=====================================
> Version 2.02.0.0010 - 02-JUL-2019 <
=====================================

- Bug Fixes
----------------------
1. The 'OutputString' method did not work in the 64-bit edition of Easy Code.

2. Fasm and SolAsm projects fired errors when there was more than one window or module in the project because Easy Code did not build well the code for external variables and procedures.

3. After creating a new project and adding an MDIWindow, Window, DialogBox or module object, the corresponding tab was not created.


- Added Features
----------------------
1. New 'opengl32.inc' and 'opengl32.lib' files for ASMC, FASM, JWASM, MASM, SOLASM and UASM 64-bit projects.


- Deprecated Features
----------------------
None


=====================================
> Version 2.02.0.0009 - 24-JUN-2019 <
=====================================

- Bug Fixes
----------------------
1. The "Project-->Add External Resources (*.res)" menu option did not work and made Easy Code to crash.

2. The menu option "Search-->Search in Files" did not work when a file extension was specified.


- Added Features
----------------------
1. Shows the Common Controls version in the about box.

2. Supports Asmc v2.30 changes EXCEPT for the "/Zne" option, which does not work with Easy Code when the Unicode mode is used. For more information please see the "IMPORTANT REMARKS" topic in the Easy Code help file.

3. A new option allows you to specify a command line for the project's executable file. For more information please see the Project Properties, Tools section, in the Easy Code help file.


- Deprecated Features
----------------------
None


=====================================
> Version 2.02.0.0008 - 12-FEB-2019 <
=====================================

- Bug Fixes
----------------------
1. Dragging and dropping a file into the IDE did not work.

2. The default project for FASM drivers did not build due to a bug in the '\EasyCode\Include\Fasm\Classic\ntoskrnl.inc' file.


- Added Features
----------------------
1. New Arabic language file (translated by MFM Dawdeh - lalalogitech@hotmail.com).


- Deprecated Features
----------------------
None


=====================================
> Version 2.02.0.0007 - 16-NOV-2018 <
=====================================

- Bug Fixes
----------------------
None


- Added Features
----------------------
1. A new custom help item has been added to the "Help" tab of the "Tools-->Settings" menu.

2. The backcolor/forecolor for the Easy Code panels ('Project Explorer', 'Properties Windows' and 'Output Window') can be changed in the "Editor" tab of the "Tools-->Settings" menu (at the end of the "Colors" list box).


- Deprecated Features
----------------------
None


=====================================
> Version 2.02.0.0006 - 06-NOV-2018 <
=====================================

- Bug Fixes
----------------------
1. Easy Code crashed when copying a single child control to clipboard. Please forgive me for this serious error.


- Added Features
----------------------
None


- Deprecated Features
----------------------
None


=====================================
> Version 2.02.0.0005 - 30-OCT-2018 <
=====================================

- Bug Fixes
----------------------
1. When changing the "Text Enconding" option, the flag for saving the project was not activated, so the new encoding mode was not saved (unless any other project option had been modified).

2. Easy Code crashed when a container object (Group, Picture, Rebar), containing child controls, was copied to clipboard.


- Added Features
----------------------
1. New 'ole32.inc', 'oleaut32.inc', 'vfw32.inc', 'ole32.lib', 'oleaut32.lib' and 'vfw32.lib' files for 64-bit ASMC, FASM, JWASM, MASM SOLASM and UASM projects.


- Deprecated Features
----------------------
None


=====================================
> Version 2.02.0.0004 - 06-JUL-2018 <
=====================================

- Bug Fixes
----------------------
1. Some unicode characters (Chinese, Russian, Arabic, etc.) were not correctly shown. Please carefully read the 'Programming Unicode applications' topic in the Easy Code help file.


- Added Features
----------------------
1. Now the code page identifier can be set in the project's 'Version' resource.


- Deprecated Features
----------------------
None


=====================================
> Version 2.02.0.0003 - 30-MAY-2018 <
=====================================

- Bug Fixes
----------------------
1. The Tab control did not appear (it was not shown even being enabled) when creating a new project.


- Added Features
----------------------
1. New 'netapi32.inc' and 'netapi32.lib' files for 64-bit ASMC, FASM, JWASM, MASM and UASM projects.

2. New 'crypt32.inc' and 'crypt32.lib' files for 64-bit ASMC, FASM, JWASM, MASM and UASM projects.


- Deprecated Features
----------------------
None


=====================================
> Version 2.02.0.0002 - 04-FEB-2018 <
=====================================

- Bug Fixes
----------------------
1. The Tab control did not appear (it was not shown even being enabled) when creating a new project.


- Added Features
----------------------
1. New 'netapi32.inc' and 'netapi32.lib' files for 64-bit ASMC, FASM, JWASM, MASM and UASM projects.

2. New 'crypt32.inc' and 'crypt32.lib' files for 64-bit ASMC, FASM, JWASM, MASM and UASM projects.


- Deprecated Features
----------------------
None


=====================================
> Version 2.02.0.0001 - 04-JAN-2018 <
=====================================

- Bug Fixes
----------------------
No bug detected.


- Added Features
----------------------
1. Added a Tab control in order to easily navigate multiple files. The tab control is visible by default (ONLY when a project is open and there is at least one open file), but it can be hidden by unchecking the 'Tab Control' option of the 'View' menu.

2. New 'lz32.inc' and 'lz32.lib' files for 64-bit ASMC, FASM, JWASM, MASM and UASM projects.

3. New 'NT Service' example for FASM, both 32-bit/64-bit.


- Deprecated Features
----------------------
None


=====================================
> Version 2.01.0.0004 - 06-DEC-2017 <
=====================================

- Bug Fixes
----------------------
1. Fixes a bug that caused a label begining with a dot (".") to be joined with the previous word (i.e. Jmp.Exit).

2. The default window procedure created by Easy Code for GoAsm and Masm 64-bit visual projects did not end the ECM_AFTERCREATE message.


- Added Features
----------------------
1. New 'richedit.inc' file for 64-bit ASMC, FASM, JWASM, MASM and UASM projects.


- Deprecated Features
----------------------
None


=====================================
> Version 2.01.0.0003 - 28-SEP-2017 <
=====================================

- Bug Fixes
----------------------
1. Syntax highlighting was not working correctly for some XML documents, depending on the syntax of the used assembler being used.

2. Fixed a bug that sometimes crashed Easy Code when writing GoAsm conditional directives (#IF, #ELSE, #ELSEIF, #ENDIF).


- Added Features
----------------------
1. New 'odbc32.inc' and 'odbc32.lib' files (database management) for 64-bit ASMC, FASM, JWASM, MASM and UASM projects.

2. New menu option 'Edit-->Snippets'. Please see the 'Easy Code Snippets' topic in the Easy Code help file.


- Deprecated Features
----------------------
None


=====================================
> Version 2.01.0.0002 - 26-JUN-2017 <
=====================================

- Bug Fixes
----------------------
1. Fixed a bug that prevented "Option win64:xx" from being properly set (partially solved in previous version with re-built executable files).

2. Fixed a bug that sometimes crashed Easy Code when writing GoAsm conditional directives (#IF, #ELSE, #ELSEIF, #ENDIF).


- Added Features
----------------------
1. New configuration files and example projects for UAsm assembler, both 32-bit and 64-bit. After running this latest version of Easy Code, the 'UAsm.cfg' and 'UAsm64.cfg' files will have been created. Remember that you must set the correct paths in both files before creating projects for this assembler (go to menu: 'Tools=>Settings', select the 'Configurations' tab, in the 'Configuration' combo box select the configuration you wish to modify ('Uasm' or 'UAsm64) and then push the 'Paths and command line options' button).


- Deprecated Features
----------------------
None


=====================================
> Version 2.01.0.0001 - 06-JUN-2017 <
=====================================

- Bug Fixes
----------------------
1. Easy Code 32-bit did not work when runnig on a VMWare virtual machine (32-bit version only).


- Added Features
----------------------
1. Added support for the 'Option win64:' directive (ASMC, JWASM and UASM64). Please see the 'Configuring Option win64:' topic in the Easy Code help file.

2. New "iphlpapi.inc" and "iphlpapi.lib" files for 64-bit applications.

3. Added the 'StartErrorHandler' and 'EndErrorHandler' macros (Structured Exception Handle) for 64-bit visual projects. For more information please see the 'Handling exceptions' topic in the Easy Code help file.

4. Added the 'Rdtscp' opcode to all 64-bit ".ori" files. You should manually add this opcode to your corresponding 64-bit ".cfg" files (in "Group4" between "Rdtsc" and "Rep"), or just copy the whole "Group4" line from the ".ori" file to the corresponding ".cfg" file.


- Deprecated Features
----------------------
None


=====================================
> Version 2.00.0.0027 - 18-MAY-2017 <
=====================================

- Bug Fixes
----------------------
1. Fixed an error that could make Easy Code to crash when adding lines to the end of the code editor.

2. Fixed some issues in the Fasm 'kernel32.inc' and 'user32.inc' files.

3. Fixed some errors in the 'StartErrorHandler' and 'EndErrorHandler' macros (Structured Exception Handle for 32-bit visual projects only). For more information please see the 'Handling exceptions' topic in the Easy Code help file.


- Added Features
----------------------
1. Added 'MIDIPlay' project examples for AsmC, Fasm, GoAsm, JWasm, Masm and PoAsm (both, 32-bit/64-bit).


- Deprecated Features
----------------------
None


=====================================
> Version 2.00.0.0026 - 06-APR-2017 <
=====================================

- Bug Fixes
----------------------
1. Fixed a pair of bugs in the "gdi32.inc" and "kernel32.inc" files (Fasm and Masm).

2. Fixed a bug in the "ntddk.h" file (GoAsm).


- Added Features
----------------------
1. Added information about de CPU and its features (MMX, SSE, etc.) in the 'About' box.

2. Added 1,076 functions ("ApiCalls.txt" file) and 2,386 constants ("ApiConst.txt" file) to the context help.

3. There are some changes in the AsmC64.ori, Fasm64.ori, GoAsm64.ori, JWasm64.ori, Masm64.ori, PoAsm.ori and PoAsm64.ori files. You should check those files in order to apply the changes to your equivalent configuration files (".cfg").


- Deprecated Features
----------------------
None


=====================================
> Version 2.00.0.0025 - 14-MAR-2017 <
=====================================

- Bug Fixes
----------------------
1. A duplicated label name in the 32-bit visual libraries made the "polink.exe" linker to fail.

2. Fixed an error in the "kernel32.inc" file ("Fasm\Visual") that could make Fasm visual projects to fail.


- Added Features
----------------------
None


- Deprecated Features
----------------------
None


=====================================
> Version 2.00.0.0024 - 08-MAR-2017 <
=====================================

- Bug Fixes
----------------------
None


- Added Features
----------------------
1. Added the new "FindString" method that searches a substring inside a string. Please see the "FindString" method in the Easy Code help file.

2. New "shlwapi.inc" and "shlwapi.lib" files for 64-bit applications.

3. New version of the "shell32.inc" and "macros.inc" files (only for 64-bit Masm projects).


- Deprecated Features
----------------------
None


=====================================
> Version 2.00.0.0023 - 24-JAN-2017 <
=====================================

- Bug Fixes
----------------------
1. Fixed some issues of the "Beautify Syntax" feature.


- Added Features
----------------------
None


- Deprecated Features
----------------------
None


=====================================
> Version 2.00.0.0022 - 20-JAN-2017 <
=====================================

- Bug Fixes
----------------------
None


- Added Features
----------------------
1. Added full support for the new "AsmC" assembler. After running this new executable of EC v2, two more configuration files will have been created in the "Config" folder ("Asm.cfg" and "AsmC64.cfg"). Please set the correct paths for these two new files.


- Deprecated Features
----------------------
None


=====================================
> Version 2.00.0.0021 - 08-DEC-2016 <
=====================================

- Bug Fixes
----------------------
1. The 'Find Unused Resources' menu option did not work correclty for 'Module' objects.


- Added Features
----------------------
1. Adds a new Turkish language file.


- Deprecated Features
----------------------
None


=====================================
> Version 2.00.0.0020 - 04-NOV-2016 <
=====================================

- Bug Fixes
----------------------
1. Fixed a bug in the 'LoByte' macro within the "ECGoAsm32.asm" and "ECGoAsm64.asm" files.

2. Fixed some bugs within the "ECMasm64.asm" macro file.

3. Fixed a bug in the editor which errantly caused the line beautifying feature to also be applied to commented lines.


- Added Features
----------------------
None


- Deprecated Features
----------------------
None


=====================================
> Version 2.00.0.0019 - 20-AUG-2016 <
=====================================

- Bug Fixes
----------------------
1. The 'Hide selected text' option, in the 'Editor' tab of the 'Settings' section, did not work when it was unchecked.


- Added Features
----------------------
1. A new option in the 'Editor' tab of the 'Settings' section ('Right margin:'), allows a vertical line to be drawn at the specified column.

2. A new method, 'OutputBuffer', saves a buffer in a binary file. For more information, please see the 'OutputBuffer' method in the Easy Code help file.


- Deprecated Features
----------------------
None


=====================================
> Version 2.00.0.0018 - 30-JUL-2016 <
=====================================

- Bug Fixes
----------------------
1. Fixed a bug in the 'IO_STATUS_BLOCK' structure of the 'ntddk' file that could fire a blue screen when running 64-bit drivers built with Fasm and/or GoAsm.

2. Fixed a bug in the Easy Code 64-bit visual libraries that affected the 'DeleteRegistryKey', 'DeleteRegistryValue', 'GetRegistryValue' and 'SetRegistryValue' methods causing them to not work.


- Added Features
----------------------
None


- Deprecated Features
----------------------
None


=====================================
> Version 2.00.0.0017 - 28-JUL-2016 <
=====================================

- Bugs Fixed
-----------------------
1. The Easy Code 'STBPANNEL' structure was defined incorrectly, affecting the 64-bit 'StatusBar' containing multiple controls and causing some elements to not be shown.


- Added Features
----------------------
1. Include and library files have been improved to reflect updates to the API in Windows 10.


- Deprecated Features
----------------------
None


=====================================
> Version 2.00.0.0016 - 22-JUN-2016 <
=====================================

- Bugs Fixed
-----------------------
1. Fixed a bug that caused Easy Code to crash when using specific keys combined with the 'Function' key [Fn] which generate the WM_APPCOMMAND message.

2. Fixed a bug that prevented 64-bit Easy Code from working properly on Windows XP-64 and Windows Vista-64.


- Added Features
----------------------
None


- Deprecated Features
----------------------
None


====================================
> Version 2.00.0.0015, 22-MAY-2016 <
====================================

- Bugs Fixed
-----------------------
None


- Added Features
----------------------
1. A new menu option, Help->Check for Updates..., allows you to check whether there is a new version of Easy Code available.  Option programmed by Héctor A. Medina.

2. New "wininet.inc" and "wininet.lib" files for 64-bit projects.

3. A new menu option, File->New File..., allows you to create new include or miscellaneous files.

4. The "readme.txt" has been renamed to "whatsnew.txt", so you should remove the "readme.txt" file from the 'EasyCode' folder.


- Deprecated Features
----------------------
None


====================================
> Version 2.00.0.0014, 08-MAY-2016 <
====================================

- Bugs Fixed
-----------------------
1. "MultiLine" Edit controls flickered when moving the mouse pointer over them - visual projects only.

2. The 64-bit 'GetCPUInfo' method did not work correctly.

3. Resources did not compile correctly when text encoding was set to UTF-8.


- Added Features
----------------------
None


- Deprecated Features
----------------------
None


====================================
> Version 2.00.0.0013, 02-APR-2016 <
====================================

- Bugs Fixed
-----------------------
1. Fixed some errors of the FASM 64-bit macro (ECFasm64.asm).

2. Fixed the issues that appeared when some windows were undocked from the IDE.


- Added Features
----------------------
1. A new "settings.exe" file allows you to associate the Easy Code files to either the 32-bit or the 64-bit executable.


- Deprecated Features
----------------------
None



====================================
> Version 2.00.0.0012, 22-MAR-2016 <
====================================

- Bugs Fixed
-----------------------
1. The 'TVI_ROOT', 'TVI_FIRST', 'TVI_LAST' and 'TVI_SORT' constants were not well defined in the "comctl32.inc" file.

2. Fixed some issues affecting to 'Accelerator' resources.

3. Removes alignment for MCI structures and Fixed a pair of bad declared structures fot 64-bit projects ("winmm.inc" file).


- Added Features
----------------------
1. A new 64-bit version of the Easy Code executable file, "EasyCode64.exe", has been added to the "...\Bin" folder.	 From now on, Easy Code will include both the 32-bit executable ("EasyCode.exe") and the 64-bit executable ("EasyCode64.exe") in its releases.	Both use the same auxiliary and configuration files, so you can run any of them without having to make any change.

2. Improved the 'Find Unused Resources' option.


- Deprecated Features
----------------------
None



====================================
> Version 2.00.0.0011, 12-FEB-2016 <
====================================

- Bugs Fixed
-----------------------
1. The default procedure for a 'DialogBox' object did not include the 'WM_INITDIALOG' message.

2. An incorrect value in the BITMAP structure of the "gdi32.inc" file adversely affected some 64-bit projects.

3. A missing API function, "CreateDirectory", has been added to the "kernel32.inc" file.


- Added Features
----------------------
None


- Deprecated Features
----------------------
None



====================================
> Version 2.00.0.0010, 20-JAN-2016 <
====================================

- Bugs Fixed
-----------------------
1. The 64-bit "ECService" example for GoASM built fine but did not run correctly because the manifest file was incorrect.

2. Some 64-bit methods (FindCollectionExactItem, FindCollectionItem, SetAlign, SetScrollBars, Update and WriteTextLine) had bugs which cause them to not work correctly, but only for the x64 visual libraries "ECLib64.lib" and "ECDll64.dll".


- Added Features
----------------------
None


- Deprecated Features
----------------------
None



====================================
> Version 2.00.0.0009, 05-JAN-2016 <
====================================

- Bugs Fixed
-----------------------
1. When creating a new FASM project, neither the "win32ax.inc"/"win32wx.inc" nor the "win64ax.inc"/"win64wx.inc" include files could be properly set in the Project Explorer.


- Added Features
----------------------
1. The user can now copy/paste controls between separate but simultaneously running instances of Easy Code 2.

2. The 'HiDWord' and 'LoDWord' macros have been optimized for all assemblers.

3. New "uxtheme.inc" and "uxtheme.lib" files related to XP Themes (Windows XP and later).


- Deprecated Features
----------------------
None



====================================
> Version 2.00.0.0008, 10-DEC-2015 <
====================================

- Bugs Fixed
-----------------------
No bug(s) detected.


- Added Features
----------------------
1. The text sent to the compiler can be encoded to UTF-8 (without B.O.M.) for all configurations.

2. New "msvcrt.inc" and "msvcrt.lib" files for 64-bit applications (the file "msvcrt.inc" is not yet completed, but most useful functions are declared).


- Deprecated Features
----------------------
None



====================================
> Version 2.00.0.0007, 02-DEC-2015 <
====================================

- Bugs Fixed
-----------------------
1. Macros in FASM projects did not work properly and could fire errors at compile time. The problem has been solved, but for Easy Code to work properly the user must also make changes to the "fasm.cfg" and "fasm64.cfg" files as is specified in the "fasm.txt" file.

2. The FASM 'struc' keyword was not recognized by Easy Code. The problem has been solved, but for Easy Code to work properly the user must also make changes to the "fasm.cfg" and "fasm64.cfg" files as is specified in the "fasm.txt" file.


- Added Features
----------------------
1. Easy Code can now open any individual "*.asm" file without having to create a project for it.


- Deprecated Features
----------------------
None



====================================
> Version 2.00.0.0006, 24-NOV-2015 <
====================================

- Bugs Fixed
-----------------------
1. When running "EasyCode.exe" from the Command Prompt, the "e" message was displayed.

2. The 'CommandLine' member of the 'App' object ('App.CommandLine') could contain a wrong command line, which caused the bug documented in the previous line.

3. Easy Code's splash screen and about box dialogs now display the correct Windows version even when running in compatibility mode.

4. When trying to add a RichEdit control to a project, Easy Code could not create it and an error was fired.

5. When a procedure, a macro, or a structure was added, the 'Properties Window' might show some empty lines (only in FASM projects).

6. The default classic project created by Easy Code (both, 32-bit and 64-bit), fired an error and could not be built (only in FASM projects).

7. When adding an object ('Button', 'Edit', etc.) to a window, Easy Code could crash (only in FASM projects).


- Added Features
----------------------
None


- Deprecated Features
----------------------
None



====================================
> Version 2.00.0.0005, 14-NOV-2015 <
====================================

- Bugs Fixed
-----------------------
1. In FASM visual projects, the 'App' object ([App.Main], [App.Instance], etc.) was not recognized in any window or module other than the main window.

2. Fixed some errors in the "shell32.inc" and "winmm.inc" files of the Easy Code "...\Include\Fasm" folder.


- Added Features
----------------------
1. New language files for Chinese, both traditional and simplified, translated by Jason Jiang (already available in previous version 2.00.0.0004 but not documented).

2. New example project for FASM, 'EC Player', a nice CD player.

3. New example project for GOASM, 'EC Player', a nice CD player.


- Deprecated Features
----------------------
None



====================================
> Version 2.00.0.0004, 01-NOV-2015 <
====================================

- Bugs Fixed
-----------------------
1. Fixed a severe bug that made Easy Code to crash when the code editor processed some characters.

2. The path for the custom help menu item 'Help #4' (Tools->Settings..., 'Help' tab) was never saved.

3. The default code was incorrect in a new module created when using the Project->Add Module menu item (classic projects only).

4. External variables and procedures, that is, those declared in another window or module, were reported as "not found" when building the project (only FASM visual projects).


- Added Features
----------------------
1. Custom help menu items 'Help #1' through 'Help #5' (Tools->Settings..., 'Help' tab) now also accept a web address (URL).


- Deprecated Features
----------------------
None



====================================
> Version 2.00.0.0003, 20-OCT-2015 <
====================================

- Bugs Fixed
-----------------------
1. Shortcut keys available in some keyboards caused Easy Code to crash if it was running without administrator privileges. This problem was related to the WM_APPCOMMAND message and has already been resolved.


- Added Features
----------------------
1. The 'BackColor' property has been added to the 'SysLink' control.

2. Five new items have been added to the 'Help' menu. Those items are customizable and allow you to define up to five more help files that may be executed from within Easy Code.  Please see the 'Configuring other help files' topic in the Easy Code help file (last part of the 'Settings' section, 'Help' tab).


- Deprecated Features
----------------------
None



====================================
> Version 2.00.0.0002, 16-OCT-2015 <
====================================

- Bugs Fixed
-----------------------
1. The 'SysLink' control appeared in the tool box but it was not implemented.  As a result, Easy Code crashed when trying to add a 'SysLink' control.


- Added Features
----------------------
1. The 'SysLink' control is already implemented.


- Deprecated Features
----------------------
None



====================================
> Version 2.00.0.0001, 08-OCT-2015 <
====================================

- Bugs Fixed
-----------------------
None.


- Added Features
----------------------
1. Initial release of Easy Code version 2.0.


- Deprecated Features
----------------------
None
